<!DOCTYPE html>
<html lang="ko"
	xmlns:th="http://www.thymeleaf.org">
<!--
 *******************************************************************************
 * @source  : GoodsTitleReserveForm.html
 * @desc    : 상품 타이틀 예약관리
 *============================================================================
 * STYLE24
 * Copyright(C) 2020 TSIT, All rights reserved.
 *============================================================================
 * VER  DATE         AUTHOR      DESCRIPTION
 * ===  ===========  ==========  =============================================
 * 1.0  2020.10.30   eskim       최초 작성
 *******************************************************************************
 -->
	<div id="main">
		<!-- 메인타이틀 영역 -->
		<div class="main-title">
		</div>
		<!-- //메인타이틀 영역 -->
		<!-- 메뉴 설명 -->
		<div class="infoBox menu-desc">
		</div>
		<form id="goodsTnmListForm" name="goodsTnmListForm" action="#" th:action="@{'/goods/title/reserve/list'}">
		<input type="hidden" id="searchGb" name="searchGb" />
		 		<!-- 패널 영역1 -->
		<div class="panelStyle" >
			<!-- TITLE -->
			<div class="panelTitle">
				<h3><i class="fa fa-info-circle"></i>아래 검색조건 중 하나를 꼭 입력해 주세요.</h3>
			</div>
			<!-- //TITLE -->
			<div class="panelContent">
				<table class="frmStyle">
					<colgroup>
						<col width="8%"/>
						<col width="10%"/>
						<col width="8%"/>
						<col width="10%"/>
						<col width="8%"/>
						<col width="20%"/>
						<col width="8%"/>
						<col/>
					</colgroup>
					<tr>
						<th>업체/브랜드</th>
						<td colspan="5">
							<select name="supplyCompCd" id="supplyCompCd">
								<option value="" th:if="${sessionInfo.roleCd} != 'G001_B000'">[전체]</option>
								<option th:if="${supplyCompList}" th:each="oneData, status : ${supplyCompList}" th:value="${oneData.cd}" th:text="${'[' + oneData.cd + '] ' + oneData.cdNm}"></option>
							</select>
							<span id="multiBrand"></span>
						</td>
						<th rowspan="2">키워드</th>
						<td rowspan="2">
							<select name="search" id="search">
								<option value="searchGoodsCd">상품코드</option>
								<option value="searchGoodsNum">품번</option>
								<option value="searchSupplyGoodsCd">업체상품코드</option>
							</select>
							<textarea class="textareaR2 w50p" name="condition" id="condition"></textarea>
						</td>
					</tr>
					<tr>
						<th>상품명</th>
						<td>
							<input type="text" class="w200" name="goodsnm" id="goodsnm" maxlength="50"/>
						</td>
						<th>예약타이틀</th>
						<td>
							<input type="text" class="w200" name="goodsTnmRes" id="goodsTnmRes" maxlength="50"/>
						</td>
						<th>시즌/년도</th>
						<td>
							<select  name="styleYear" id="styleYear">
								<option value="">[전체]</option>
								<option th:if="${styleYearList}" th:each="oneData, status : ${styleYearList}" th:value="${oneData.cd}" th:text="${'[' + oneData.cd + '] ' + oneData.cdNm}"></option>
							</select>
							<select  name="seasonCd" id="seasonCd">
								<option value="">[전체]</option>
								<option th:if="${seasonList}" th:each="oneData, status : ${seasonList}" th:value="${oneData.cd}" th:text="${'[' + oneData.cd + '] ' + oneData.cdNm}"></option>
							</select>
						</td>
					</tr>
					<tr>
						<th>예약일</th>
						<td colspan="7" id="sellTerms"></td>
					</tr>
				</table>
				<ul class="panelBar">
					<li class="center">
						<button type="button" class="btn btn-gray btn-lg" id="btnInit" >초기화</button>
						<button type="button" class="btn btn-info btn-lg" id="btnSearch" >조회</button>
					</li>
				</ul>	
			</div>
			<!-- //검색조건 영역 -->
		</div>
		<!-- 패널 영역1 -->
		<div class="panelStyle">
			<!-- 검색결과 영역 -->
			<!-- 상단버튼 영역  -->
			<ul class="panelBar">
				<li>
					<button type="button" class="btn btn-default btn-lg" onclick="cfnDownloadSampleFile('SF003');">상품엑셀조회 양식 다운로드</button>
					<button type="button" class="btn btn-base btn-lg" id="btnGoodsExcelUpLoad">엑셀조회</button>
					<button type="button" class="btn btn-success  btn-lg" id="btnGoodsTnmResSave">예약등록</button>
					<button type="button" class="btn btn-danger btn-lg" id="btnGoodsTnmResDelete">예약삭제</button>
				</li>
				<li class="right">
					검색결과 : <strong><span id="gridRowTotalCount">0</span> 건</strong>&nbsp;
					
					쪽번호 <span id="pgNo">0</span>/ <strong id="endPgNo">0</strong>&nbsp;&nbsp;
					<select id="pageSize" name="pageSize">
						<option value="50" selected="selected">50개씩 보기</option>
						<option value="100">100개씩 보기</option>
						<option value="500">500개씩 보기</option>
						<!-- <option value="1000">1000개씩 보기</option> -->
					</select>
					<input type="hidden" name="pageNo" id="pageNo" value ="1"/>
				</li>
			</ul>
			<!-- //상단버튼 영역  -->
			<div id="gridList" style="width: 100%; height: 550px;" class="ag-theme-balham"></div>
			<ul class="panelBar">
				<li class="center">
					<div class="tablePaging" id="goodsListPagination"></div>
				</li>
			</ul>
			<!-- 검색결과 영역 -->
		</div>
		</form>
		<!-- //패널 영역2 -->
	</div>
<script type="text/javascript" src="/ux/plugins/gaga/gaga.paging.js?v=2019072202"></script>
<script th:inline="javascript">
/*<![CDATA[*/
	var sessRoleCd = [[${sessionInfo.roleCd}]];
	var goodsStatList = gagajf.convertToArray([[${goodsStatList}]]);
	var formalGbList = gagajf.convertToArray([[${formalGbList}]]);

	var columnDefs = [
		{width: 40, minWidth: 40, cellClass: 'text-right', headerCheckboxSelection: true, checkboxSelection: true, filter: false},
		{headerName: 'No', width: 60, cellClass: 'text-center',
			valueGetter: function(params) { return cfnGridNumner('goodsTnmListForm',params.node.rowIndex, 'A');}
		},
		{headerName: "브랜드명", field: "brandGrpNm", width: 130, cellClass: 'text-center'},
		{headerName: "상품코드", field: "goodsCd", width: 140, cellClass: 'text-center'},
		{headerName: "상품명", field: "goodsNm", width: 180, cellClass: 'text-left'
			,cellRenderer: function(params) {
				return '<a href="javascript:void(0);">' + params.value + '</a>';
			}
		},
		{headerName: "상품타이틀", field: "goodsTnm", width: 200, cellClass: 'text-left'},
		{headerName: "예약상품타이틀", field: "regGoodsTnm", width: 200, cellClass: 'text-left'},
		{headerName: "예약시작일시", field: "applyStdt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD HH:mm:ss") : '';
			}
		},
		{headerName: "예약종료일시", field: "applyEddt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD HH:mm:ss") : '';
			}
		},
		{headerName: "상품상태", field: "goodsStat" , width: 100, cellClass: 'text-center',
			cellEditorParams: { values: gagaAgGrid.extractValues(goodsStatList) },
			valueFormatter: function (params) { return gagaAgGrid.lookupValue(goodsStatList, params.value); },
			valueParser: function (params) { return gagaAgGrid.lookupKey(goodsStatList, params.newValue); }
		},
		{headerName: "등록일시", field: "regDt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD HH:mm:ss") : '';
			}
		},
		{headerName: "등록자", field: "regNm", width: 100, cellClass: 'text-center'},
		{headerName: "상품타이틀예약순번", field: "goodsTnmResSq", hide: true}
	];
	
	// Get GridOptions
	var gridOptions = gagaAgGrid.getGridOptions(columnDefs);

	// 중복 선택 가능
	gridOptions.rowSelection = 'multiple';
	gridOptions.suppressRowClickSelection = true;
	//gridOptions.rowHeight = 60; //이미지가 있을경우 높이 지정해야함.

	// Row Click
	gridOptions.onCellClicked = function(event) {
		var goodsCd = event.data.goodsCd;
		if (event.colDef.field == "goodsNm"){
			cfnOpenGoodsDetailPopup('U',goodsCd);
		}else if (event.colDef.field == "goodsCd"){
			
		}
	}

	// 초기화 클릭시
	$('#btnInit').on('click', function() {
		fnInit();
	});
	
	var fnInit = function(){
		$("#goodsTnmListForm input[name=siteCd]").prop("disabled", true);
		$("#goodsTnmListForm input[name=siteCd]").addClass("formControl");
		
		$('#goodsTnmListForm')[0].reset();
		//$("#goodsTnmListForm input[type=radio]").removeClass("checked");
		$("#goodsTnmListForm input[type=checkbox]").removeClass("checked");
		//$("#goodsTnmListForm input[type=radio]").parent("label").removeClass("checked");
		$("#goodsTnmListForm input[type=checkbox]").parent("label").removeClass("checked");
		$("#goodsTnmListForm input[type=radio][checked]").parent("label").addClass("checked");
		$("#multiBrand").empty();
	}
	
	// 조회클릭시
	$('#btnSearch').on('click', function() {
		$("#goodsTnmListForm input[name=pageNo]").val('1');
		fnGoodsTnmListSearch('BASIC');
	});

	// 조회
	var fnGoodsTnmListSearch = function(gbn) {
		
		if (typeof(gbn) != 'undefined' &&  gbn == 'EXCEL'){
			$("#goodsTnmListForm input[name=searchGb]").val("EXCEL");
		}else{
			$("#goodsTnmListForm input[name=searchGb]").val("BASIC");
		}
		
		if(!fnConditionCheck()) return;
		
		gagaPaging.init('goodsTnmListForm', fnSearchCallBack, 'goodsListPagination', $('#goodsTnmListForm').find('#pageSize').val());
		gagaPaging.load($("#goodsTnmListForm input[name=pageNo]").val());
	}

	// 조회 (등록 창 닫을 때)
	var fnGoodsRsvtTnmListSearch = function(gbn) {

		if (typeof(gbn) != 'undefined' &&  gbn == 'EXCEL'){
			$("#goodsTnmListForm input[name=searchGb]").val("EXCEL");
		}else{
			$("#goodsTnmListForm input[name=searchGb]").val("BASIC");
		}

		gagaPaging.init('goodsTnmListForm', fnSearchCallBack, 'goodsListPagination', $('#goodsTnmListForm').find('#pageSize').val());
		gagaPaging.load($("#goodsTnmListForm input[name=pageNo]").val());
	}

	//검색 조건 확인
	var fnConditionCheck = function(){
		var formId = '#goodsTnmListForm';
		var form = document.goodsTnmListForm;

		if (event.keyCode === 13) return false;
		
		if($("#goodsTnmListForm input[name=searchGb]").val() == "EXCEL") return true;
		
		var searchFlag = false;
		var cnt = 0;

		/* if( !gagajf.isNull($("#goodsTnmListForm select[name=supplyCompCd]").val())
				|| !gagajf.isNull($("#goodsTnmListForm input[name=condition]").val())
				|| (!gagajf.isNull($("#goodsTnmListForm input[name=stDate]").val()) && !gagajf.isNull($("#goodsTnmListForm input[name=edDate]").val()))
			){
			searchFlag = true;
		}else{ */
			for (i = 0; i < form.elements.length; i++ ) {
				var el = form.elements[i];
				if ($(el).prop("type") == "text" || $(el).prop("type") == "textarea" || ($(el).prop("type") == "select-one" && el.name != "search" && el.name != "pageSize")) {
					if (!(el.value == null || el.value == "")) {
						cnt++;
					}
				}
			}
			
			if(cnt > 0) searchFlag = true;
			
		/* } */
		
		if(searchFlag == false){
			mcxDialog.alert("검색조건을 입력하세요.");
			return false;
		}
		
		var fromDate = $('#goodsTnmListForm input[name=stDate]').val();
		var toDate = $('#goodsTnmListForm input[name=edDate]').val();
		
		if (!gagajf.isNull(fromDate) || !gagajf.isNull(toDate)) {
			
			if (gagajf.isNull(fromDate) || gagajf.isNull(toDate)) {
				mcxDialog.alertC("등록일 조회시 시작일자와 종료일자를 입력하세요.", {
					sureBtnText: "확인",
					sureBtnClick: function() {
						$('#goodsTnmListForm input[name=stDate]').focus();
					}
				});
				return false;
			}

			if (fromDate > toDate) {
				mcxDialog.alert("노출기간 시작일자는 종료일자 보다 클 수 없습니다.", {
					sureBtnText: "확인",
					sureBtnClick: function() {
						$('#goodsTnmListForm input[name=stDate]').focus();
					}
				});
				return false;
			} 
		}
		
		if (!gagajf.isNull($('#goodsTnmListForm textarea[name=condition]').val())){
			var arrData = $('#goodsTnmListForm textarea[name=condition]').val().replace(/\r\n/g,"\n").split("\n"); 
			if (arrData.length > 500){
				mcxDialog.alertC("키워드 조회값을 500 이하로 조회 하세요.", {
					sureBtnText: "확인",
					sureBtnClick: function() {
						$('#goodsTnmListForm textarea[name=condition]').focus();
					}
				});
				return false;
			}
		}

		return true;
	}
	
	var fnSearchCallBack = function(result){

		$('#goodsTnmListForm').find('#gridRowTotalCount').html(result.pageing.pageable.totalCount.addComma());
		$('#goodsTnmListForm').find('#pageNo').val(result.pageing.pageable.pageNo.addComma());
		$('#goodsTnmListForm').find('#pgNo').html(result.pageing.pageable.pageNo.addComma());
		$('#goodsTnmListForm').find('#endPgNo').html(result.pageing.pageable.totalPage.addComma());
		gridOptions.api.setRowData(result.goodsTnmList);
		gagaPaging.createPagination(result.pageing.pageable);
	}
	
	//페이징 
	$('#goodsTnmListForm select[name=pageSize]').on('change', function() {
		$("#goodsTnmListForm input[name=pageNo]").val('1');
		fnGoodsTnmListSearch($("#goodsTnmListForm input[name=searchGb]").val());
	});
	
	//업체변경시
	$('#goodsTnmListForm select[name=supplyCompCd]').on('change', function() {
		var actionUrl = '/renderer/supplyCompany/brand/list/' + $(this).val();

		if(sessRoleCd == "G001_B000"){
			actionUrl = '/renderer/brand/AuthBrandlist';
		}
		cfnCreateMultiCombo(actionUrl,"multiBrand",  "[전체]",null, 'Y');
	});
	
	//엑셀 상품 조회
	$('#btnGoodsExcelUpLoad').on('click', function() {
		cfnExcelUploadPopup('goodsTnmExcelUpload', 'goodsTnmExcelUpload');
	});
	
	var goodsTnmExcelUpload = function(result){
		var data = {procJob : result.procJob
					,excelFileNm : result.excelFileNm
					};
		var jsonData = JSON.stringify(data);
		gagajf.ajaxJsonSubmit('/goods/search/excelupload/save', jsonData, fnGoodsTnmExcelUploadCallBack);
	}
	
	var fnGoodsTnmExcelUploadCallBack = function(result){
		fnGoodsTnmListSearch("EXCEL");
	}
	
	//예약등록 팝업
	$('#btnGoodsTnmResSave').click(function(e) {
		var actionUrl = "/goods/title/reserve/popup/form";
		cfnOpenModalPopup(actionUrl, 'popupGoodsTitleReserve'); 
	});
	
	//예약삭제
	$('#btnGoodsTnmResDelete').click(function(e) {
		//상품선택여부 확인처리 추가
		var selectedData = gridOptions.api.getSelectedRows();

		if (selectedData.length == 0) {
			mcxDialog.alert('선택된 행이 없습니다.');
			return false;
		}
		
		var arrGoodsCd = [];
		var arrGoodsTnmResSq = [];
		var chkFlag = false;
		//selectedData = gagaAgGrid.getAllRowData(gridOptions);
		$.each(selectedData, function(idx, item) {
			
			if (gagajf.isNull(item.goodsTnmResSq) || item.goodsTnmResSq == "0"){
				chkFlag = true;
				mcxDialog.alert(item.goodsCd +"상품은 상품타이틀이 예약된 상품이 아닙니다.");
				return false;
			}
			
			var toDateStr = new Date().format("YYYYMMDDHHmmss");
			if (toDateStr > item.applyEddt){
				chkFlag = true;
				mcxDialog.alertC("종료된 예약 상품은 삭제할 수 없습니다.", {
					sureBtnText: "확인",
					sureBtnClick: function() {
						$('#goodsRsvtTnmForm input[name=applyEdYMD]').focus();
					}
				});
				return false;
			}
		
			arrGoodsCd.push(item.goodsCd);
			arrGoodsTnmResSq.push(item.goodsTnmResSq);
		});

		if (chkFlag){
			return;
		}
		
		mcxDialog.confirm('삭제하시겠습니까?',  {
			cancelBtnText: "취소",
			sureBtnText: "확인",
			sureBtnClick: function(){
				var data = {arrGoodsCd : arrGoodsCd
						,arrGoodsTnmResSq : arrGoodsTnmResSq
			};
			
			var jsonData = JSON.stringify(data);
			gagajf.ajaxJsonSubmit('/goods/title/reserve/delete', jsonData, fnGoodsTnmResDeleteCollBack);
			}
		});
	});
	
	var fnGoodsTnmResDeleteCollBack = function(){
		//fnGoodsRsvtTnmListSearch($("#goodsTnmListForm input[name=searchGb]").val());
	}
	
	$(document).ready(function() {

		cfnCreateCalendar('#sellTerms', 'applyStdt', 'applyEddt', true, '예약일', 'X');
		var chkBeforSkipFlag = '&nbsp;&nbsp;<label class="chkBox"><input type="checkbox" name="beforSkipFlag" value="Y" >이전데이터 제외</label>';
		$("#goodsTnmListForm").find('#sellTerms').append(chkBeforSkipFlag);
		
		// Create a agGrid
		gagaAgGrid.createGrid('gridList', gridOptions);

	});

/*]]>*/
</script>
 	
</html>